indexing

   description: "A single MIME field as it occurs in the entity headers."
   
   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   EPX_MIME_FIELD


creation
   
   make
   

feature -- creation
   
   make (a_name, a_value: STRING; a_parameters: ARRAY[EPX_MIME_PARAMETER]) is
      require
         valid_name: a_name /= Void and then not a_name.is_empty
         valid_value: a_value /= Void and then not a_value.is_empty
         -- `parameters' contains strings of form attribute = value
      do
         name := a_name
         name.to_lower
         value := a_value
         parameters := a_parameters
      end
   

feature -- state

   name: STRING
         -- name of MIME field, lowercase only
   
   value: STRING
   
   parameters: ARRAY[EPX_MIME_PARAMETER]
   

feature -- queries   
   
   parameter (a_name: STRING): EPX_MIME_PARAMETER is
         -- return parameter value
      local
         lname: STRING
         i: INTEGER
         found: BOOLEAN
      do
         create lname.make_from_string (a_name)
         lname.to_lower
         from
            found := False
            i := parameters.lower
         until
            found or else i > parameters.upper
         loop
            Result := parameters.item (i)
            found := Result.name.is_equal (lname)
            i := i + 1
         end
         
         check
            found implies Result /= Void
         end
         
         if not found then
            Result := Void
         end
      end
   

invariant
   
   has_name: name /= Void and then not name.is_empty
   
   has_value: value /= Void

   
end -- class EPX_MIME_FIELD
