#include "s_in.h"
#include <arpa/inet.h>


/* network to host conversions */

EIF_INTEGER posix_htons (EIF_INTEGER host16value)
{
  return htons(host16value);
}

EIF_INTEGER posix_ntohs (EIF_INTEGER net16value)
{
  return ntohs(net16value);
}


/* struct sockaddr_in */

EIF_INTEGER posix_sockaddr_in_size()
{
   return (sizeof (struct sockaddr_in));
}

EIF_INTEGER posix_sockaddr_in_sin_family(struct sockaddr_in *p)
{
  return p->sin_family;
}

EIF_INTEGER posix_sockaddr_in_sin_port(struct sockaddr_in *p)
{
  return p->sin_port;
}

EIF_POINTER posix_sockaddr_in_sin_addr(struct sockaddr_in *p)
{
  return (EIF_POINTER) & (p->sin_addr);
}


void posix_set_sockaddr_in_sin_family(struct sockaddr_in *p, EIF_INTEGER sin_family)
{
  p->sin_family = sin_family;
}

void posix_set_sockaddr_in_sin_port(struct sockaddr_in *p, EIF_INTEGER sin_port)
{
  p->sin_port = sin_port;
}

void posix_set_sockaddr_in_sin_addr(struct sockaddr_in *p, EIF_POINTER sin_addr)
{
  memcpy(&(p->sin_addr), sin_addr, sizeof(struct in_addr));
}
