indexing

   description: "Class that covers the Single Unix Spec sys/socket.h header."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class

   SAPI_SOCKET

   
feature {NONE} -- functions
   
   posix_connect (a_socket: INTEGER; a_address: POINTER; a_address_len: INTEGER): INTEGER is
         -- connect a socket
      require
         valid_socket: a_socket >= 0
         valid_address: a_address /= default_pointer
         valid_length: a_address_len > 0
      external "C"
      ensure
         -- Result = -1 implies errno is set
      end
   
   posix_socket (a_family, a_type, a_protocol: INTEGER): INTEGER is
         -- create an endpoint for communication
      external "C"
      ensure
         -- Result = -1 implies errno is set
      end

   
feature {NONE} -- C binding for members of sockaddr

   posix_sockaddr_size: INTEGER is
      external "C"
      end

   posix_sockaddr_sa_family (a_sockaddr: POINTER): INTEGER is
         -- address family: AF_xxx value
      external "C"
      end

   posix_sockaddr_sa_data (a_sockaddr: POINTER): POINTER is
         -- ptr to protocol-specific address buffer
      external "C"
      end

   posix_set_sockaddr_sa_family (a_sockaddr: POINTER; sa_family: INTEGER) is
      external "C"
      end


end
