indexing

   description: "Converts strings to pointers and vice versa."
   thanks: "The mico/E team for the idea."

   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class

   EPX_STRING_HELPER


inherit

   ABSTRACT_STRING_HELPER


feature -- VisualEiffel specific conversions

   string_to_pointer (s: STRING): POINTER is
      do
         if s = Void then
            Result := default_pointer
         else         
            Result := s.to_external
         end
      end

   pointer_to_string (p: POINTER): STRING is
      do
         !! result.make_empty
         if p /= default_pointer then
            result.from_c (p)
         end
      end

   set_string_from_pointer (s: STRING; p: POINTER) is
      do
         if p = default_pointer then
            s.wipe_out
         else
            s.from_c (p)
         end
      end

   
feature -- string utilities that have different names per compiler...   
   
   clear (s: STRING) is
      do
         s.wipe_out
      end
   
   insert_character (s: STRING; c: CHARACTER; i: INTEGER) is
      do
         s.insert_character (c, i)
      end
   
   make_with_capacity (capacity: INTEGER): STRING is
         -- create a new string
      do
         create Result.make_filled ('%U', capacity)
         Result.wipe_out
      end
   
   
end
