indexing

   description: "Class that covers Standard C environment variable routines."

   usage: "Models one (possibly existing) variable."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   STDC_ENV_VAR

inherit
   
   STDC_BASE

   CAPI_STDLIB

creation

   make
   
   
feature   
   
   make (a_name: STRING) is
      require
         valid_name: a_name /= Void and then not a_name.is_empty
         -- `a_name' doesn't have to be an existing variable
      do
         name := a_name
      end
   

feature -- queries
   
   exist: BOOLEAN is
         -- returns True if this environment variable is defined
      local
         cvalue: POINTER
      do
         cvalue := posix_getenv (sh.string_to_pointer (name))
         Result := cvalue /= default_pointer
      end
   
   
   name: STRING

   value: STRING is
      local
         cvalue: POINTER
      do
         cvalue := posix_getenv (sh.string_to_pointer (name))
         Result := sh.pointer_to_string (cvalue)
      ensure
         -- contents of environment variable `name' if it exists
         -- or else the empty string
         not_void: Result /= Void
      end


end -- class STDC_ENV_VAR
