indexing

   description: "Class that covers Windows current system info related",
   "routines."

   usage: "Just inherit from this class."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class 

   WINDOWS_SYSTEM


inherit

   STDC_SYSTEM


feature -- compile-time determined queries
   
   arg_max: INTEGER is
         -- The lenght of arguments for the exec() function
      do
         Result := posix_arg_max
      end

   child_max: INTEGER is
         -- The number of simultaneous processes per real user ID
      do
         Result := posix_child_max
      end

   stream_max: INTEGER is
         -- The maximum number of streams that one process can have 
         -- open at one time.
      do
         Result := posix_stream_max
      end
   
   tzname_max: INTEGER is
         -- The maximum number of bytes in a timezone name.
      do
         Result := posix_tzname_max      
      end

   open_max: INTEGER is
         -- The maximum number of files that one process can have 
         -- open at one time.
      do
         Result := posix_open_max
      end


end -- class WINDOWS_SYSTEM
