indexing

   description: "Test STDC_PATH class."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"

class TEST_PATH

creation
   
   make
   
feature

   make is
      local
         env_home: STDC_ENV_VAR
         p: STDC_PATH
      do
         print ("Test portable path handling. There should be no output.%N")

         create env_home.make ("HOME")
         test ("dir", "dir")
         test ("~/tmp", env_home.value + "/tmp")
         test ("~\tmp", env_home.value + "/tmp")
         test ("$HOME", env_home.value)
         test ("$HOME/tmp", env_home.value + "/tmp")
         test ("%%HOME%%/tmp", env_home.value + "/tmp")
         test ("${HOME}/tmp", env_home.value + "/tmp")
         test ("$(HOME)/tmp", env_home.value + "/tmp")
         test ("tmp/test~", "tmp/test~")
         test ("\winnt\system32", "/winnt/system32")
         test ("$NOT_EXIST_QQ/dir", "/dir")

         create p.make_expand ("/usr/local/bin")
         if not p.is_portable then
            print ("!! not portable.%N")
         end
         
         -- test path parsing         
         create p.make_from_string ("test.e")
         p.parse (<<".e">>)
         check_parse (p, "", "test", ".e")
         create p.make_from_string ("/a/b/c/test.e")
         p.parse (Void)
         check_parse (p, "/a/b/c", "test.e", "")
         create p.make_from_string ("../test.e")
         p.parse (<<".c">>)
         check_parse (p, "..", "test.e", "")
         create p.make_from_string ("../test.e")
         p.parse (<<".c", ".e">>)
         check_parse (p, "..", "test", ".e")
         
         print ("End test portable path handling.%N")
      end

   test (path, expected: STRING) is
      local
         p: STDC_PATH
         s: STRING
      do
         create p.make_expand (path)
         create s.make_from_string (p)
         if not expected.is_equal(s) then
            print ("!! Expected: '")
            print (expected)
            print ("', got: '")
            print (p)
            print ("'.%N")
         end
      end
   
   check_parse (p: STDC_PATH; dir, name, suffix: STRING) is
      do
         if not dir.is_equal (p.directory) then
            print ("!! directory not equal: ")
            print (dir)
            print (" /= ")
            print (p.directory)
            print ("%N")
         end
         if not name.is_equal (p.basename) then
            print ("!! basename not equal: ")
            print (name)
            print (" /= ")
            print (p.basename)
            print ("%N")
         end
         if not suffix.is_equal (p.suffix) then
            print ("!! suffix not equal: ")
            print (suffix)
            print (" /= ")
            print (p.suffix)
            print ("%N")
         end         
      end

   
end -- class TEST_PATH
